/* ============================================================================
 * File Name: `$INSTANCE_NAME`.c
 * Version `$CY_MAJOR_VERSION`.`$CY_MINOR_VERSION`
 * 
 * Description:
 *   Exponential Moving Average digital component(v 0.0)
 *   Averages digital singnal using exponential moving average 
 *   Options: 
 *      variable input and output bus width and dumping factor
 *      output decimator with variable lenght
 *      digital set input 
 *      strobe synchronization
 *
 * Note:
 *
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/

#include <`$INSTANCE_NAME`.h> // must specify API prefix in Symbol->Properties->Doc.APIPrefix

#define UDB_DELAY 3     // num ticks = Timer_Period + 3 
static uint16 nTicks;   // requested amaount of ticks


//==============================================================================
// Initialize and Start
//==============================================================================

void  `$INSTANCE_NAME`_Start() 
{
    `$INSTANCE_NAME`_Timer_Start(); //must go first
    `$INSTANCE_NAME`_SetPeriod((uint16) `$INSTANCE_NAME`_Clk_Ticks); 
    
    //nTicks = `$INSTANCE_NAME`_Clk_Ticks; // UDB actual: val+3
    //`$INSTANCE_NAME`_Timer_WritePeriod(nTicks-UDB_DELAY); // 
    //`$INSTANCE_NAME`_Timer_WriteCounter(0); // see KBA88172 - Dynamically Changing Period Value     
}

//==============================================================================
// Trigger
//==============================================================================

uint8 `$INSTANCE_NAME`_Trigger()     
{
    `$INSTANCE_NAME`_ControlReg_Trig_Write(1); //trigger ClockX_1
    return 0;
}

//==============================================================================
// Set number of pulses
//==============================================================================

uint8 `$INSTANCE_NAME`_SetPeriod(uint16 value)             
{ 
    //if (value < 0) return 1;
    if (value < UDB_DELAY) return 1;
    //if (value > 0xFFFF) return 1;
    
    nTicks = value; // store new value
    `$INSTANCE_NAME`_Timer_WritePeriod(nTicks-UDB_DELAY); // UDB actual: val+3 
    `$INSTANCE_NAME`_Timer_WriteCounter(0); // see KBA88172 - Dynamically Changing Period Value 
    return 0;
}

//==============================================================================
// Set number of pulses
//==============================================================================

uint16 `$INSTANCE_NAME`_GetPeriod()             
{ 
    return nTicks;
}
//==============================================================================
/* [] END OF FILE */
