/* ============================================================================
 * File Name: `$INSTANCE_NAME`.h
 * Version `$CY_MAJOR_VERSION`.`$CY_MINOR_VERSION`
 * 
 * Description:
 *   Exponential Moving Average digital component(v 0.0)
 *   Averages digital singnal using exponential moving average 
 *   Options: 
 *      variable input and output bus width and dumping factor
 *      output decimator with variable lenght
 *      digital set input 
 *      strobe synchronization
 *
 * Note:
 *
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/

#ifndef `$INSTANCE_NAME`_H
#define `$INSTANCE_NAME`_H

#include <project.h>
    
/***************************************
*   Conditional Compilation Parameters
***************************************/
#define true 1
#define false 0
    
// read-only parameters->     
#define `$INSTANCE_NAME`_Bit_Width   `=$bit_width`   // counter width 
#define `$INSTANCE_NAME`_Clk_Ticks   `=$clk_ticks`  // 
 
    
/***************************************
*           API Constants
***************************************/  

    

/***************************************
*           Registers
***************************************/
// todo: where to declare best?    
//#define `$INSTANCE_NAME`_out0_PTR	((reg8 *)  `$INSTANCE_NAME`_sEN_sStatus0_StatusReg_out0__STATUS_REG)  

/***************************************
*           properties
***************************************/   

#define `$INSTANCE_NAME`_Period `$INSTANCE_NAME`_GetPeriod()
    
/***************************************
*        Function Prototypes
***************************************/

//#if   (`$INSTANCE_NAME`_Outp_Width <= 8u) 
//    uint8 `$INSTANCE_NAME`_Read8();             // read output bus width 1 to 8
//#elif (`$INSTANCE_NAME`_Outp_Width <= 16u)
//    uint16 `$INSTANCE_NAME`_Read16();           // read output bus width 9 to 16
//#endif
 
void   `$INSTANCE_NAME`_Start();                 // initialize component
uint8  `$INSTANCE_NAME`_SetPeriod(uint16 value); // set nymber of pulses 
uint16 `$INSTANCE_NAME`_GetPeriod();             // return num clock Ticks
uint8  `$INSTANCE_NAME`_Trigger();               // trigger 




#endif /* `$INSTANCE_NAME`_H */

/* [] END OF FILE */
